import { StatusCodes } from 'botframework-schema';
import { InvokeResponse } from './invokeResponse';
/**
 * A custom exception for invoke response errors.
 */
export declare class InvokeException<T = unknown> extends Error {
    private readonly status;
    private readonly response?;
    /**
     * @param status The Http status code of the error.
     * @param response optional. The body of the exception. Default is null.
     */
    constructor(status: StatusCodes, response?: T);
    /**
     * A factory method that creates a new [InvokeResponse](xref:botbuilder-core.InvokeResponse) object with the status code and body of the current object.
     *
     * @returns A new [InvokeResponse](xref:botbuilder-core.InvokeResponse) object.
     */
    createInvokeResponse(): InvokeResponse;
}
//# sourceMappingURL=invokeException.d.ts.map